#!/bin/bash

TYPE="${1:-all}"

if [[ "$TYPE" == "all" || "$TYPE" == "taxonomies" ]]; then
  # Taxonomies.
  drush migrate:import drupalorg_migrate_forums --update
  drush migrate:import drupalorg_migrate_screenshots --update
  drush migrate:import drupalorg_migrate_module_categories --update
  drush migrate:import drupalorg_migrate_drupal_version --update
  drush migrate:import drupalorg_migrate_core_compatibility --update
  drush migrate:import drupalorg_migrate_release_type --update
  # @todo probably don't need the issue tags.
  drush migrate:import drupalorg_migrate_issue_tags --update
  drush migrate:import drupalorg_migrate_page_status --update
  drush migrate:import drupalorg_migrate_front_page_news --update
  drush migrate:import drupalorg_migrate_audience --update
  drush migrate:import drupalorg_migrate_maintenance_status --update
  drush migrate:import drupalorg_migrate_development_status --update
  drush migrate:import drupalorg_migrate_services --update
  drush migrate:import drupalorg_migrate_sectors --update
  drush migrate:import drupalorg_migrate_locations --update
  drush migrate:import drupalorg_migrate_keywords --update
  drush migrate:import drupalorg_migrate_level --update
  drush migrate:import drupalorg_migrate_license --update
  drush migrate:import drupalorg_migrate_book_availability --update
  drush migrate:import drupalorg_migrate_book_format --update
  drush migrate:import drupalorg_migrate_areas_of_expertise --update
  drush migrate:import drupalorg_migrate_organization_type --update
  drush migrate:import drupalorg_migrate_tags --update
  drush migrate:import drupalorg_migrate_contribution_area --update
  drush migrate:import drupalorg_migrate_hosting_features --update
fi

if [[ "$TYPE" == "all" || "$TYPE" == "users" ]]; then
  # Users and roles.
  drush migrate:import drupalorg_migrate_user_roles --update
  # IMPORTANT: the following will take HOURS unless you truncate the number of D7-users somehow.
  # You can run these sql commands:
  #   DELETE FROM migrate.users WHERE uid > 500;
  #   UPDATE migrate.node SET uid = 1 where uid > 500;
  #   UPDATE migrate.files SET uid = 1 where uid > 500;
  #   UPDATE migrate.node_revision SET uid = 1 where uid > 500;
  drush migrate:import drupalorg_migrate_users --update
fi

if [[ "$TYPE" == "all" || "$TYPE" == "files" ]]; then
  # @TODO how to place files in server.
  # Files
  drush migrate:import drupalorg_migrate_project_files
fi

if [[ "$TYPE" == "all" || "$TYPE" == "project-browser" ]]; then
  # Content & Paragraphs.
  drush migrate:import drupalorg_migrate_organizations --update
  drush migrate:import drupalorg_migrate_field_collection_supporting_organizations --update
  drush migrate:import drupalorg_migrate_project_module --update
  drush migrate:import drupalorg_migrate_project_core --update
  drush migrate:import drupalorg_migrate_project_distribution --update
  drush migrate:import drupalorg_migrate_project_drupalorg --update
  drush migrate:import drupalorg_migrate_project_theme --update
  drush migrate:import drupalorg_migrate_project_theme_engine --update
  drush migrate:import drupalorg_migrate_project_translation --update
  # @todo Releases not used yet in PB.
  #drush migrate:import drupalorg_migrate_field_collection_release_files --update
  #drush migrate:import drupalorg_migrate_project_release --update
fi

if [[ "$TYPE" == "all" || "$TYPE" == "usage" ]]; then
  # Project usage data
  ## Needed to truncate the table locally due to memory limits. Just the delete query took minutes to run.
  ## DELETE FROM project_usage_week_release WHERE timestamp < 1633219200; -- October 2021
  drush migrate:import drupalorg_migrate_project_usage_week_release
fi
